-- This include file extends the math functions available with the following :

-- PI        This is the value 3.1415926 modified with more digits by GVL
-- e         This is the constaint 'e' redefined by G. V. Lozada
-- deg_rad   -rename of deg by G. V. Lozada
-- rad_deg
-- abs
-- ceiling
-- frac 
-- dec_frac
-- perm_n_by_r
-- mod
-- log_10
-- exp
-- sinh
-- cosh
-- tanh
-- matrix_add  This function will add or subtract to n x n matrixes
-- matrix_mult Thsi function will multiply to n x n matrixes
-----------------------------------------------------------------------------
-- Added by Gerardo V. Lozada, 24-September-1997/11-October-1997
-- arccos	-	Arc Cosine
-- arcsin	-	Arc Sine
-- sgn	-	Sign of argument
-- pi redefined
-- e redefined
-- deg_rad in place of deg
-----------------------------------------------------------------------------
--Added/redefined From Andy Montgomery's math.e
--arccosh - inverse cosh
--arcsinh - inverse sinh
--arctanh - inverse tanh
--fib - Fibonacci Series
--factorial - factorial function
--min - minimum
--max - maximum
--Constants c_gr, cgrneg, nan, inf

global constant pi = 4*arctan(1.0),
				e = 2.718281828459045,
                c_gr=1.6180339887499,
                c_grneg=1 - c_gr,
                nan=-(2*power(10,308)/(3*power(10,308))),
                inf=2*power(10,308)

global function sgn(object x)
	object y
	if sequence(x) then
		y=repeat(0.0,length(x))
		for i=1 to length(x) do
			y[i]=sgn(x[i])
		end for
	else
		if x<0.0 then
			y=-1
		else
			y=1
		end if
	end if
	return y
end function

global function sign(object x)
	return sgn(x)
end function

global function deg_rad(object x)
--syntax sin(deg_rad(x))
	return x*pi/180.0
end function
       
global function rad_deg(object x)
	return x*180.0/pi
end function


global function factorial(object x)
object result
if sequence(x) then
    result=repeat(0,length(x))
    for count=1 to length(x) do
        result[count]=factorial(x[count])
    end for
elsif integer(x) then
    if x>0 then
        result=x*factorial(x-1)
    elsif x=0 then
        result=1
    else
        result=nan
    end if
else
    result=nan
end if
return result
end function

global function logbase(atom y, object x)
	object result
	if sequence(x) then
		result = repeat(0,length(x))
		for count=1 to length(x) do
			result[count] = logbase(y,x[count])
		end for
	else
    	if (x>0 and y>0) then
			result = log(x)/log(y)
		else
			result = nan
		end if
	end if
	return result
end function

global function log_10(object x)
	return logbase(10.0,x)
end function

global function abs(object x)
	object y
	if sequence(x) then
		y=repeat(0.0,length(x))
		for i=1 to length(x) do
			y[i]=abs(x[i])
		end for
	else
	   if x<0 then
			y=-x
		else
			y=x
		end if
	end if
	return y
end function

global function frac(object x)
	object y
	if sequence(x) then
		y=repeat(0.0,length(x))
		for i=1 to length(x) do
			y[i]=frac(x[i])
		end for
	else
		if abs((floor(x))) = x then 
			y=0.0
		else
		    y=x-floor(x)
		end if
	end if
	return y
end function

global function dec_frac(object x)
	atom numerator, denominator
	object y
	if sequence(x) then
		y=repeat({0.0,0.0},length(x))
		for i=1 to length(x) do
			y[i]=dec_frac(x[i])
		end for
	else	
		numerator = 1
		denominator = 2
		for q = denominator to 1000 do
			for r = numerator to q - 1 do
				if abs(x - (r/q)) < .00003  then
					y={r,q}
				end if
			end for
		end for
	end if
	return y
end function

global function mod(object x,atom z)
	object y
	if sequence(x) then
		y=repeat(0.0,length(x))
		for i=1 to length(x) do
			y[i]=mod(x[i],z)
		end for
	else
		if abs(z)>0.0 then
			y = abs(x -z * abs(floor(x/z)))*sgn(x/z)
		else
			y=0.0
		end if
	end if
	return y
end function
       
global function ceiling(object x)
	object y
	if sequence(x) then
		y=repeat(0.0,length(x))
		for i=1 to length(x) do
			y[i]=ceiling(x[i])
		end for
	else
	    if (floor(x)< x) then
			y=(floor(x)+1)
		else
			y=x   
		end if
	end if
	return y
end function

global function exp(object x)
	object y
	if sequence(x) then
		y=repeat(0.0,length(x))
		for i=1 to length(x) do
			y[i]=exp(x[i])
		end for
	else
		y = power (e,x)
	end if
	return y
end function

global function perm_n_by_r(atom n, atom r)
	  n = (factorial(n))/(factorial(n-r))
	  return n
end function

global procedure pascal_triangle(atom rows)
	atom c
	for n = 0  to rows-1  do
		for r = 0  to n   do
			c = 1
			for x = n  to n-r+1  by -1  do
				c=c*x/(n-x+1)
			end for
			printf(1,"%d ",c)
		end for
		puts(1,"\n")
	end for
end procedure

global function sinh(object x)
	object y
	if sequence(x) then
		y=repeat(0.0,length(x))
		for i=1 to length(x) do
			y[i]=sinh(x[i])
		end for
	else
		y = .5 * (exp(x)-exp(-x))
	end if
	return y
end function
       
global function cosh(object x)
	object y
	if sequence(x) then
		y=repeat(0.0,length(x))
		for i=1 to length(x) do
			y[i]=cosh(x[i])
		end for
	else
		y = .5 * (exp(x)+exp(-x))
	end if
	return y
end function
       
global function tanh(object x)
	object y
	if sequence(x) then
		y=repeat(0.0,length(x))
		for i=1 to length(x) do
			y[i]=tanh(x[i])
		end for
	else
		y = 1-2*exp(-x)/(exp(x)+exp(-x))
	end if
	return y
end function

global function matrix_add(sequence a,sequence b,atom row,atom column,atom s)
	sequence c
	c= repeat (repeat({0},row),column)
	for j = 1  to row   do
		for i = 1 to column do
	    	if s = 2 then
				b[j][i] = -b[j][i] 
	    	end if
		    c[j][i] = { a[j][i] + b[j][i]}
		end for
    end for
    return c
end function           
	   
global function matrix_mult(sequence a,sequence b,atom row,atom column)
	sequence c
	c= repeat (repeat({0},row),column)
	for j = 1  to row   do
		for i = 1 to column do
		    c[j][i] = { a[j][i] * b[j][i]}
		end for
    end for
    return c
end function           
 
global function arccos(object x)
	object y
	if sequence(x) then
		y=repeat(0.0,length(x))
		for i=1 to length(x) do
			y[i]=arccos(x[i])
		end for
	else
		if abs(x)>1.0 then
			return nan
		end if
		if (abs(x)>0.0) then
			y=arctan(abs(sqrt(1.0-power(x,2))/x))
			if (x<0.0) then
				y=pi-y
			end if
		else
			y=pi/2
		end if
	end if
	return y
end function

global function arcsin(atom x)
	object y
	if sequence(x) then
		y=repeat(0.0,length(x))
		for i=1 to length(x) do
			y[i]=arcsin(x[i])
		end for
	else
		if abs(x)>1.0 then
			y=nan
		end if
		if (abs(x)<1.0) then
			y=arctan(x/sqrt(1.0-power(x,2)))
		else
			if (x>0.0) then
				y=pi/2
			else
				y=-pi/2
			end if
		end if
	end if
	return y
end function

global function arccosh(object x)
object result
if sequence(x) then
    result = repeat(0,length(x))
    for count=1 to length(x) do
        result[count] = arccosh(x[count])
    end for
else
    if x>=1 then
        result = log(x + sqrt(x*x - 1))
    else
        result = nan
    end if
end if
return result
end function

global function arcsinh(object x)
object result
if sequence(x) then
    result = repeat(0,length(x))
    for count=1 to length(x) do
        result[count] = arcsinh(x[count])
    end for
else
    result = log(x + sqrt(x*x + 1))
end if
return result
end function

global function arctanh(object x)
object result
if sequence(x) then
    result = repeat(0,length(x))
    for count=1 to length(x) do
        result[count] = arctanh(x[count])
    end for
else
    if (x>-1 and x<1) then
        result = log(sqrt((x + 1)/(1 - x)))
    elsif (x=-1 or x=1) then
        result = inf*x
    else
        result = nan
    end if
end if
return result
end function

global function int(object x)
	return floor(x)
end function

global function ln(object x)
object result
if sequence(x) then
    result = repeat(0,length(x))
    for count=1 to length(x) do
        result[count] = ln(x[count])
    end for
else
    if x=0 then
        result = -inf
    elsif x>0 then
        result = log(x)
    else
        result = nan
    end if
end if
return result
end function

global function log10(object x)
return logbase(10,x)
end function

global function max(object x)
atom result
if sequence(x) then
    result = x[1]
    for count=2 to length(x) do
        if atom(x[count]) then
        if x[count]>result then
            result = x[count]
        end if
        end if
    end for
else
    result = x
end if
return result
end function

global function min(object x)
atom result
if sequence(x) then
    result = x[1]
    for count=2 to length(x) do
        if atom(x[count]) then
        if x[count]<result then
            result = x[count]
        end if
        end if
    end for
else
    result = x
end if
return result
end function

global function mean(object x)
atom result
result = 0
if sequence(x) then
    for count=1 to length(x) do
        x[count] = mean(x[count])
        result = result + x[count]
    end for
    result = result/length(x)
else
    result = x
end if
return result
end function

global function oned(object x)
sequence result
if sequence(x) then
    result = {}
    for count=1 to length(x) do
        result = result & oned(x[count])
    end for
else
    result = {x}
end if
return result
end function

global function median(object x)
atom result, average, diff, lowest
if sequence(x) then
    average = mean(x)
    x = oned(x)
    lowest = abs(x[1] - average)
    result = x[1]
    for count=1 to length(x) do
        diff = abs(x[count] - average)
        if diff<lowest then
            lowest = diff
            result = x[count]
        end if
    end for
else
    result = x
end if
return result
end function

global function fib(object x)
object result
if sequence(x) then
    result=repeat(0,length(x))
    for count=1 to length(x) do
        result[count]=fib(x[count])
    end for
elsif (integer(x) and x>=0) then
    result=int((power(c_gr,x)-power(c_grneg,x))/sqrt(5))
else
    result=nan
end if
return result
end function
